[parted-devel] [PATCH 1/3] tests: add one: try to remove a busy partition

Otavio Salvador otavio at ossystems.com.br
Tue Jun 29 17:56:05 UTC 2010


This test try to reproduce the issue reported in Debian bug #582818[1].

 1. http://bugs.debian.org/582818

Basically it does:

 * create two primary partitions
 * mount the second one
 * remove the first (must works)
 * try to remove the second (must fail)

* tests/t1101-busy-partition.sh: new file.
* tests/Makefile.am: add the new test in check target.
---
 tests/Makefile.am             |    1 +
 tests/t1101-busy-partition.sh |   86 +++++++++++++++++++++++++++++++++++++++++
 2 files changed, 87 insertions(+), 0 deletions(-)
 create mode 100755 tests/t1101-busy-partition.sh

diff --git a/tests/Makefile.am b/tests/Makefile.am
index aa67f99..a1ab0d8 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -19,6 +19,7 @@ TESTS = \
   t0400-loop-clobber-infloop.sh \
   t0500-dup-clobber.sh \
   t1100-busy-label.sh \
+  t1101-busy-partition.sh \
   t1700-ext-probe.sh \
   t2100-mkswap.sh \
   t2200-dos-label-recog.sh \
diff --git a/tests/t1101-busy-partition.sh b/tests/t1101-busy-partition.sh
new file mode 100755
index 0000000..0a1dfa6
--- /dev/null
+++ b/tests/t1101-busy-partition.sh
@@ -0,0 +1,86 @@
+#!/bin/sh
+# test for Debian bug #582818 (http://bugs.debian.org/582818); forbid
+# the removal of a mounted partition.
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  parted --version
+fi
+
+: ${srcdir=.}
+. $srcdir/t-lib.sh
+
+require_root_
+require_scsi_debug_module_
+
+# create memory-backed device
+scsi_debug_setup_ dev_size_mb=80 > dev-name ||
+  skip_test_ 'failed to create scsi_debug device'
+dev=$(cat dev-name)
+
+cat <<EOF > exp-warning || framework_failure
+WARNING: you are attempting to use parted to operate on (mkpartfs) a file system.
+parted's file system manipulation code is not as robust as what you'll find in
+dedicated, file-system-specific packages like e2fsprogs.  We recommend
+you use parted only to manipulate partition tables, whenever possible.
+Support for performing most operations on most types of file systems
+will be removed in an upcoming release.
+EOF
+
+cat <<EOF > exp-error || framework_failure
+Error: Partition ${dev}2 is being used. You must unmount it before you modify it with Parted.
+EOF
+
+fail=0
+
+parted -s "$dev" mklabel msdos > out 2>&1 || fail=1
+
+# expect no output
+compare out /dev/null || fail=1
+
+parted -s "$dev" mkpartfs primary fat32 1 40 > out 2>&1 || fail=1
+
+# expect warning
+compare out exp-warning || fail=1
+
+parted -s "$dev" mkpartfs primary fat32 40 80 > out 2>&1 || fail=1 
+
+# wait for new partition device to appear
+wait_for_dev_to_appear_ ${dev}2
+
+# expect warning
+compare out exp-warning || fail=1
+
+# be sure to unmount upon interrupt, failure, etc.
+cleanup_() { umount "${dev}2" > /dev/null 2>&1; }
+
+mount_point="`pwd`/mnt"
+
+mkdir $mount_point || fail=1
+mount "${dev}2" $mount_point || fail=1
+
+# removal of unmounted partition, must work.
+parted -s "$dev" rm 1 > out 2>&1 || fail=1
+
+parted -s "$dev" rm 2 > out 2>&1 && fail=1
+
+# expect error
+compare out exp-error
+
+Exit $fail
+
-- 
1.7.1.569.g6f426




More information about the parted-devel mailing list